import * as React from 'react';
import PlotlyEditor from 'react-chart-editor';
import 'react-chart-editor/lib/react-chart-editor.css';
export interface IGraphDivData {
    mode: string;
    type: string;
    uid: string;
    x: any[];
    xsrc: string;
    y: any[];
    ysrc: string;
    [key: string]: any;
}
export declare type Data = IGraphDivData[];
export declare type Layout = {};
export declare type Frames = any[];
export interface PlotlyEditorState {
    data: Data;
    layout: Layout;
    frames?: Frames;
}
export interface ChartEditorProps {
    state?: PlotlyEditorState;
    handleUpdate?: (state: PlotlyEditorState) => void;
    plotly: any;
}
export interface ChartEditorState {
    data: Data;
    layout: Layout;
    frames: Frames;
}
export default class ChartEditor extends React.Component<ChartEditorProps, ChartEditorState> {
    constructor(props: ChartEditorProps);
    static getDerivedStateFromProps(nextProps: ChartEditorProps, prevState?: ChartEditorState): ChartEditorState;
    handleUpdate: (data: IGraphDivData[], layout: Layout, frames: any[]) => void;
    handleRender: (data: IGraphDivData[], layout: Layout, frames: any[]) => void;
    handleResize: () => void;
    render(): JSX.Element;
    ref: PlotlyEditor;
}
