"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_chart_editor_1 = require("react-chart-editor");
require("react-chart-editor/lib/react-chart-editor.css");
var ChartEditor = /** @class */ (function (_super) {
    __extends(ChartEditor, _super);
    function ChartEditor(props) {
        var _this = _super.call(this, props) || this;
        _this.handleUpdate = function (data, layout, frames) {
            _this.setState(function () { return ({
                data: data,
                layout: layout,
                frames: frames
            }); });
            _this.props.handleUpdate({ data: data, layout: layout, frames: frames });
        };
        _this.handleRender = function (data, layout, frames) {
            _this.props.handleUpdate({ data: data, layout: layout, frames: frames });
        };
        _this.handleResize = function () {
            if (_this.ref.state.graphDiv instanceof HTMLElement)
                _this.props.plotly.Plots.resize(_this.ref.state.graphDiv);
        };
        var initialState = {
            data: props.state ? props.state.data || [] : [],
            layout: props.state ? props.state.layout || {} : {},
            frames: props.state ? props.state.frames || [] : []
        };
        // TODO: Remove after upgrading to React 16.3
        _this.state = initialState;
        return _this;
    }
    ChartEditor.getDerivedStateFromProps = function (nextProps, prevState) {
        return prevState;
    };
    ChartEditor.prototype.render = function () {
        var _this = this;
        var plotly = this.props.plotly;
        var _a = this.state, data = _a.data, layout = _a.layout, frames = _a.frames;
        var config = { editable: true };
        return (React.createElement("div", { className: "container" },
            React.createElement(react_chart_editor_1.default, { ref: function (ref) {
                    _this.ref = ref;
                }, className: "plotly-editor", data: data, layout: layout, config: config, frames: frames, plotly: plotly, onUpdate: this.handleUpdate, onRender: this.handleRender, useResizeHandler: true, debug: true, advancedTraceTypeSelector: true })));
    };
    return ChartEditor;
}(React.Component));
exports.default = ChartEditor;
