import { Widget } from '@phosphor/widgets';
import { IRenderMime } from '@jupyterlab/rendermime-interfaces';
import '../style/index.css';
/**
 * The MIME type for Plotly Editor.
 */
export declare const MIME_TYPE = "application/vnd.plotly-editor.v1+json";
export declare class RenderedPlotlyEditor extends Widget implements IRenderMime.IRenderer {
    /**
     * Create a new widget for rendering Plotly Editor.
     */
    constructor(options: IRenderMime.IRendererOptions);
    /**
     * Dispose of the resources used by the widget.
     */
    dispose(): void;
    /**
     * Render Plotly Editor into this widget's node.
     */
    renderModel(model: IRenderMime.IMimeModel): Promise<void>;
    /**
     * A message handler invoked on a `'resize'` message.
     */
    protected onResize(msg: Widget.ResizeMessage): void;
    /**
     * A message handler invoked on an `'update-request'` message.
     */
    protected onUpdateRequest(): void;
    private _mimeType;
    private _ref;
}
/**
 * A mime renderer factory for Plotly Editor.
 */
export declare const rendererFactory: IRenderMime.IRendererFactory;
declare const extensions: IRenderMime.IExtension | IRenderMime.IExtension[] | any;
export default extensions;
